class rare_marker:
    _THRESHOLD = 5


    def __init__(self, get_rare, train_name):
        self._train_name = train_name
        self._get_rare = get_rare
        self._rare_list = set()
        self._make_rare_list()


    def _make_rare_list(self):
        word_count = {}
        with open(self._train_name) as f_train:
            for l in f_train:
                line = l.strip()
                fields = line.split()
                if len(fields) != 0:
                    if fields[0] in word_count:
                        word_count[fields[0]] = word_count[fields[0]] + 1
                    else:
                        word_count[fields[0]] = 1
        
        for word in word_count.keys():
            if word_count[word] < self._THRESHOLD:
                self._rare_list.add(word)


    def get_rare_train(self, out_obj = None):
        with open(self._train_name) as f_train:
            for l in f_train:
                line = l.strip()
                fields = line.split()
                if len(fields) == 0:
                    print >> out_obj, l ,    # l contains '\n'. Suppress '\n' by print
                else:
                    if fields[0] in self._rare_list:
                        print >> out_obj, self._get_rare(fields[0]), fields[1]
                    else:
                        print >> out_obj, l ,    # l contains '\n'. Suppress '\n' by print
